## nsis 3.02.1

=== debian/changelog ===
nsis (3.02.1-1) experimental; urgency=low

  * New 3.02.1 upstream release
  * Bump debhelper compat to 10
  * Bump Standards-Version to 4.0.1 without changes needed

 -- Didier Raboud <odyx@debian.org>  Thu, 31 Aug 2017 20:44:15 +0200

nsis (3.01-1) experimental; urgency=medium

  * New 3.01 upstream release
  * Drop all patches, all included upstream

 -- Didier Raboud <odyx@debian.org>  Fri, 16 Dec 2016 13:15:34 +0100

nsis (3.0-5) experimental; urgency=medium

  * Backport upstream workaround for '#1156 zlibCompressionTest loops
    endlessly'

 -- Didier Raboud <odyx@debian.org>  Sun, 11 Dec 2016 09:40:39 +0100

nsis (3.0-4) experimental; urgency=medium

  * Only build in parallel in builds without arch-all packages, to circumvent
    arch:all FTBFS

 -- Didier Raboud <odyx@debian.org>  Fri, 09 Dec 2016 16:15:19 +0100

nsis (3.0-3) experimental; urgency=medium

  [ Thomas Gaugler ]
  * makensis man page: OUTPUTCHARSET is not applicable for POSIX systems
  * Added Patch: WinWStrDupFromChar writes beyond allocated memory
  * Updated plugin api library description (new: amd64 & unicode)
  * Added Patch: Make WinWStrDupFromWC endian agnostic

  [ Didier Raboud ]
  * Add BUILD_ARCH endianness test at the start of the build-indep target

 -- Didier Raboud <odyx@debian.org>  Wed, 05 Oct 2016 08:40:53 +0200

nsis (3.0-2) experimental; urgency=low

  * Build makensis in build-indep to fix indep-only FTBFS

 -- Didier Raboud <odyx@debian.org>  Fri, 12 Aug 2016 17:24:06 +0200

nsis (3.0-1) experimental; urgency=low

  * New 3.0 upstream release

  [ Thomas Gaugler ]
  * Remove all patches for new upstream release
  * Build installer for win32 and win64
  * Use secure URL for Vcs-Browser field
  * Changed debian/copyright into a standard, machine-readable format
  * Build all plugins for win64
  * Removed unused nsis.lintian-overrides file
  * Updated makensis man page
  * Remove duplicate AUTHOR section in LibraryLocal man page
  * Remove duplicate AUTHOR section in GenPat man page
  * Simplify extraction of Version from changelog
  * Removed obsolete and completed tasks from TODO file

  [ Didier Raboud ]
  * Add missing dpkg-dev versioned B-D for dpkg-parsechangelog's --show-field
  * Re-add patch to statically link libstdc++ for plugins

 -- Didier Raboud <odyx@debian.org>  Fri, 12 Aug 2016 14:36:48 +0200

=== debian/control ===
Source: nsis
Section: devel
Priority: optional
Maintainer: Thomas Gaugler <thomas@dadie.net>
Uploaders:
 Didier Raboud <odyx@debian.org>,
Build-Depends:
 debhelper (>= 10.2.5~),
 docbook-xsl-ns,
 docbook5-xml,
 dpkg-dev (>= 1.17.0),
 html2text,
 libcppunit-dev,
 mingw-w64 (>= 1.0),
 scons (>= 1.2.0),
 xsltproc,
 zlib1g-dev,
Standards-Version: 4.0.1
Homepage: http://nsis.sourceforge.net/
Vcs-Git: https://alioth.debian.org/anonscm/git/collab-maint/nsis.git
Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/nsis.git

Package: nsis
Architecture: any
Depends:
 nsis-common (>= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 mingw-w64 (>= 1.0),
 nsis-doc (>= ${source:Version}),
 nsis-pluginapi (>= ${source:Version}),
 wine [amd64 i386 kfreebsd-amd64 kfreebsd-i386 powerpc],
Description: Nullsoft Scriptable Install System (modified for Debian)
 NSIS is a tool for creating quick and user friendly installers for
 Microsoft Windows (Win32) operating systems.
 .
 NSIS creates installers that are capable of installing, uninstalling,
 setting system settings, extracting files, etc. Because it's based on
 script files, you can fully control every part of your installers. The
 script language supports variables, functions, string manipulation,
 just like a normal programming language - but designed for the creation
 of installers. Even with all these features, NSIS is still the smallest
 installer system available. With the default options, it has an overhead
 of only 34 KB.

Package: nsis-common
Architecture: all
Depends:
 ${misc:Depends},
Replaces:
 nsis (<< 2.46-4),
Breaks:
 nsis (<< 2.46-4),
Description: Nullsoft Scriptable Install System stubs and plugins
 NSIS is a tool for creating quick and user friendly installers for
 Microsoft Windows (Win32) operating systems.
 .
 This package contains the stubs and plugins of NSIS.

Package: nsis-pluginapi
Architecture: all
Depends:
 ${misc:Depends},
Replaces:
 nsis (<< 2.46-4),
Breaks:
 nsis (<< 2.46-4),
Recommends:
 mingw-w64 (>= 1.0),
Enhances:
 nsis (>= ${source:Version}),
Description: Nullsoft Scriptable Install System plugin API
 NSIS is a tool for creating quick and user friendly installers for
 Microsoft Windows (Win32) operating systems.
 .
 This package contains the header and library files for developing
 NSIS plugins.

Package: nsis-doc
Section: doc
Architecture: all
Depends:
 ${misc:Depends},
Replaces:
 nsis (<< 2.46-4),
Breaks:
 nsis (<< 2.46-4),
Description: Nullsoft Scriptable Install System documentation
 NSIS is a tool for creating quick and user friendly installers for
 Microsoft Windows (Win32) operating systems.
 .
 This package contains examples and the documentation in HTML format.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Exclude .svn directories from packages
export DH_ALWAYS_EXCLUDE=.svn

# Enable hardening
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

VERSION=$(shell dpkg-parsechangelog --show-field Version)
PREFIX=/usr
DATADIR=$(PREFIX)/share/nsis
DOCDIR=$(PREFIX)/share/doc/nsis
SYSCONF=/etc
BUILDDIR=build
UNICODE=yes
TESTDIR=$(CURDIR)/$(BUILDDIR)/test

# Variables for Win32/Win64 cross compiler
XGCC_W32_X86 = i686-w64-mingw32-gcc
XGCC_W32_X86_PATH = $(abspath $(shell $(XGCC_W32_X86) -print-file-name=libkernel32.a)/../..)
XGCC_W32_X86_PREFIX = $(subst -gcc,-,$(XGCC_W32_X86))
XGCC_W32_AMD64 = x86_64-w64-mingw32-gcc
XGCC_W32_AMD64_PATH = $(abspath $(shell $(XGCC_W32_AMD64) -print-file-name=libkernel32.a)/../..)
XGCC_W32_AMD64_PREFIX = $(subst -gcc,-,$(XGCC_W32_AMD64))


# Evaluate parallel build option
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
ifeq (,$(shell dh_listpackages -i))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	SCONSFLAGS = -j $(NUMJOBS)
endif
endif

# Honor hardening flags
SCONSHOSTFLAGS = APPEND_CCFLAGS="$(shell dpkg-buildflags --get CPPFLAGS) \
  $(shell dpkg-buildflags --get CFLAGS)" \
  APPEND_LINKFLAGS="$(shell dpkg-buildflags --get LDFLAGS)"

SCONSOPTS = $(SCONSFLAGS) VERSION=$(VERSION) \
  PREFIX=$(PREFIX) PREFIX_CONF=$(SYSCONF) CHMDOCS=0 \
  STRIP_CP=no \
  $(if $(findstring nostripfull,$(DEB_BUILD_OPTIONS)),STRIP_W32=no,)

ifneq (,$(UNICODE),yes)
	SCONSOPTS += UNICODE=yes
	BUILDTYPE := u
endif

ifneq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
	SCONSOPTS += DEBUG=yes
	BUILDTYPE := $(BUILDTYPE)debug
else
	BUILDTYPE := $(BUILDTYPE)release
endif

ifdef XGCC_W32_X86_PATH
SCONSOPTS_X86 = PREFIX_PLUGINAPI_INC=$(XGCC_W32_X86_PATH)/include/ \
  PREFIX_PLUGINAPI_LIB=$(XGCC_W32_X86_PATH)/lib/ \
  XGCC_W32_PREFIX=$(XGCC_W32_X86_PREFIX) \
  TARGET_ARCH=x86
endif

ifdef XGCC_W32_AMD64_PATH
SCONSOPTS_AMD64 = PREFIX_PLUGINAPI_INC=$(XGCC_W32_AMD64_PATH)/include/ \
  PREFIX_PLUGINAPI_LIB=$(XGCC_W32_AMD64_PATH)/lib/ \
  XGCC_W32_PREFIX=$(XGCC_W32_AMD64_PREFIX) \
  TARGET_ARCH=amd64
endif

COMMA := ,

UTILS_ALL = 'Library/LibraryLocal,Library/RegTool,MakeLangId,Makensisw,NSIS Menu,UIs,SubStart,VPatch/Source/GenPat,zip2exe'

IGNORE_UTILS_NSIS   := $(subst Library/LibraryLocal$(COMMA),,$(UTILS_ALL))
IGNORE_UTILS_NSIS   := $(subst $(COMMA)VPatch/Source/GenPat,,$(IGNORE_UTILS_NSIS))
IGNORE_UTILS_COMMON := $(subst $(COMMA)Library/RegTool$,,$(UTILS_ALL))
IGNORE_UTILS_COMMON := $(subst $(COMMA)UIs,,$(IGNORE_UTILS_COMMON))

IGNORE_UTILS_CLEAN  := $(IGNORE_UTILS_COMMON)
IGNORE_UTILS_CLEAN  := $(subst Library/LibraryLocal$(COMMA),,$(IGNORE_UTILS_COMMON))
IGNORE_UTILS_CLEAN  := $(subst $(COMMA)VPatch/Source/GenPat,,$(IGNORE_UTILS_CLEAN))

SCONSOPTS_HOST   := $(SCONSHOSTFLAGS) $(SCONSOPTS) \
  SKIPUTILS=$(IGNORE_UTILS_NSIS) SKIPDOC=COPYING
SCONSOPTS_COMMON := $(SCONSOPTS) SKIPUTILS=$(IGNORE_UTILS_COMMON) \
  SKIPDOC=COPYING
SCONSOPTS_CLEAN  := $(SCONSOPTS) SKIPUTILS=$(IGNORE_UTILS_CLEAN)

INSTALL_nsis = install-utils install-compiler install-conf
INSTALL_FLAGS_nsis = $(SCONSOPTS_HOST)
INSTALL_nsis-common = install-stubs install-plugins install-data install-utils
INSTALL_FLAGS_nsis-common = $(SCONSOPTS_COMMON)
INSTALL_nsis-pluginapi = install-pluginapi
INSTALL_FLAGS_nsis-pluginapi = $(SCONSOPTS_COMMON)
INSTALL_nsis-doc = install-examples install-doc
INSTALL_FLAGS_nsis-doc = $(SCONSOPTS_HOST)

# Exclude test scripts which are not appropriate for POSIX platforms.
IGNORE_TESTS = makensis.nsi|gfx.nsi

# Path to .nsi scripts
SCRIPTS_PATH = $(DOCDIR)/Examples

define DO_SCONS_INSTALL
	scons $(INSTALL_FLAGS_$(1)) $(2) PREFIX_DEST="$(CURDIR)/debian/$(1)" $(INSTALL_$(1)) || exit 1;
endef

# Substitute reference to License text file in Modern UI examples
# with source file to enable their compilation with makensis
define SANITIZE_MODERN_UI
	for f in $$(find "$(1)" -type f -name '*.nsi' -print0 | xargs -0 -n 1 basename); \
	do \
		sed -i \
		-e "s&\$${NSISDIR}\\\\Docs\\\\Modern UI\\\\License.txt&$${f}&g" \
		"$(1)/$${f}"; \
	done
endef

# Replace duplicate files with symbolic link
define SYMLINK_DUPLICATES
	for f in $$(ls -1 "$(1)"); \
	do \
		cmp -s "$(1)/$${f}" "$(2)/$${f}"; \
		if [ $$? -eq 0 ]; \
		then \
			ln -sf "$(3)/$${f}" "$(2)/$${f}"; \
			echo $${f}; \
		fi; \
	done
endef

%:
	dh "$@"

override_dh_auto_clean:
	scons -c $(SCONSOPTS_CLEAN) 2>&1
	-rm -rf .sconf_temp .sconsign.dblite SCons/Tools/crossmingw.pyc build config.log .test $(TESTDIR)
	-rm -f Source/exehead/sconf.h Source/version.h Source/defines.h config.log

$(BUILDDIR)/NEWS:
	scons $(SCONSOPTS_HOST) Docs/src; \
	html2text -nobs "$(BUILDDIR)/$(BUILDTYPE)/Docs/html/AppendixF.html" | \
	sed -e '0,/^\*\*\*\*\*/c\NSIS Release Notes (automatically converted from AppendixF.html)' -e 's/F\.[.0-9]* //g' -e 's/^\*\*\*\** *\([^*]*\)  *\**\*\*\*/\n\1\n/g' -e '/Changelog/d' -e '/^NSIS_1.x_version_history/,/^=/c\    http://nsis.sourceforge.net/download/nsis1/' -e 's/^\(Released.*\)/    \1\n/g' | cat -s > "$@"

# Convert DocBook to man page
$(BUILDDIR)/%.1: debian/%.xml
	xsltproc --nonet --output $@ $<

override_dh_auto_build-arch: $(BUILDDIR)/NEWS $(BUILDDIR)/GenPat.1 $(BUILDDIR)/LibraryLocal.1 $(BUILDDIR)/makensis.1
	scons $(SCONSOPTS_HOST) utils makensis

override_dh_auto_build-indep: $(BUILDDIR)/NEWS
	# nsis-common must be built on little-endian
	[ "$(shell dpkg-architecture -qDEB_BUILD_ARCH_ENDIAN)" = "little" ]
	
	scons $(SCONSOPTS_HOST) makensis
ifdef XGCC_W32_X86_PATH
	scons $(SCONSOPTS_COMMON) $(SCONSOPTS_X86) stubs plugins utils
endif
ifdef XGCC_W32_AMD64_PATH
	scons $(SCONSOPTS_COMMON) $(SCONSOPTS_AMD64) stubs plugins utils
endif
	html2text -style pretty -nobs -o "$(BUILDDIR)/README.Modern UI" "Contrib/Modern UI/Readme.html"
	html2text -style pretty -nobs -o "$(BUILDDIR)/README.Modern UI 2" "Contrib/Modern UI 2/Readme.html"
	html2text -style pretty -nobs -o $(BUILDDIR)/README.VPatch Contrib/VPatch/Readme.html
	html2text -style pretty -nobs -o $(BUILDDIR)/README.InstallOptions Contrib/InstallOptions/Readme.html
	html2text -style pretty -nobs -o $(BUILDDIR)/README.MultiUser Contrib/MultiUser/Readme.html
	html2text -style pretty -nobs -o $(BUILDDIR)/README.nsDialogs Contrib/nsDialogs/Readme.html

override_dh_auto_test-arch:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	scons $(SCONSOPTS_HOST) test-code
endif

override_dh_auto_test-indep:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	test -x "$(BUILDDIR)/$(BUILDTYPE)/makensis/makensis" && \
	scons $(SCONSOPTS_HOST) PREFIX_DEST="$(TESTDIR)"\
		$(INSTALL_nsis) && \
	scons $(SCONSOPTS_COMMON) $(SCONSOPTS_X86) PREFIX_DEST="$(TESTDIR)" \
		$(INSTALL_nsis-common) $(INSTALL_nsis-doc) && \
	scons $(SCONSOPTS_COMMON) $(SCONSOPTS_AMD64) PREFIX_DEST="$(TESTDIR)" \
		$(INSTALL_nsis-common) && \
	$(call SANITIZE_MODERN_UI,$(TESTDIR)$(DOCDIR)/Examples/Modern UI) && \
	for script_path in $(TESTDIR)$(SCRIPTS_PATH)/*.nsi \
		$(TESTDIR)$(SCRIPTS_PATH)/*/*.nsi; do \
		script=$${script_path#$(TESTDIR)$(SCRIPTS_PATH)/}; \
		if [ "$${script%/*}" != "$${script}" ]; then \
			mkdir -p "$(TESTDIR)/$${script%/*}"; \
		fi; \
		case $${script} in \
		$(IGNORE_TESTS)) ;; \
		*) \
		if [ -f "$${script_path}" ]; then \
			PATH=$(TESTDIR)$(PREFIX)/bin:$(PATH) \
			NSISDIR=$(TESTDIR)$(DATADIR) \
			NSISCONFDIR=$(TESTDIR)$(SYSCONF) \
			"$(TESTDIR)$(PREFIX)/bin/makensis" \
			"$${script_path}" \
			-X"OutFile \"$(TESTDIR)/$${script%.nsi}.exe\"" \
			|| exit 1; \
		fi;; \
		esac; \
	done; 
	# Fail the build if libwinpthread is needed at runtime (see #722898)
	test `find $(TESTDIR)$(DATADIR)/Plugins -iname "*.dll" -exec objdump -p {} \; | grep -E "file format|DLL Name" | grep -cim1 libwinpthread` -eq 0
endif

override_dh_auto_install-arch:
	$(foreach p,$(shell dh_listpackages -a),$(call DO_SCONS_INSTALL,$(p)))

override_dh_fixperms-arch:
	dh_fixperms
	find "$(CURDIR)/debian/nsis/$(SYSCONF)" \
		-type f -perm /111 -exec chmod a-x {} \;

override_dh_auto_install-indep:

## nsis 3.03

=== SConstruct ===
EnsureSConsVersion(1,2)

stubs = [
	'bzip2',
	'lzma',
	'zlib'
]

plugin_libs = [
	'ExDLL'
]

plugins = [
	'AdvSplash',
	'Banner',
	'BgImage',
	'Dialer',
	'InstallOptions',
	'LangDLL',
	'Library/TypeLib',
	'Math',
	'nsDialogs',
	'nsExec',
	'NSISdl',
	'Splash',
	'StartMenu',
	'System',
	'UserInfo',
	'VPatch/Source/Plugin',
]

utils = [
	'Library/LibraryLocal',
	'Library/RegTool',
	'MakeLangId',
	'Makensisw',
	'NSIS Menu',
	'UIs',
	'SubStart',
	'VPatch/Source/GenPat',
	'zip2exe'
]

misc = [
	'Graphics',
	'Language files',
	'MultiUser',
	'Modern UI',
	'Modern UI 2',
	'VPatch'
]

doc = [
	'COPYING'
]

doctypes = [
	'chm',
	'html',
	'htmlsingle'
]

######################################################################
#######  Build Environment                                         ###
######################################################################

path = ARGUMENTS.get('PATH', '')
toolset = ARGUMENTS.get('TOOLSET', '')
arch = ARGUMENTS.get('TARGET_ARCH', 'x86')

if toolset and path:
	defenv = Environment(TARGET_ARCH = arch, ENV = {'PATH' : path}, TOOLS = toolset.split(',') + ['zip'])
else:
	if path:
		defenv = Environment(TARGET_ARCH = arch, ENV = {'PATH' : path})
	if toolset:
		defenv = Environment(TARGET_ARCH = arch, TOOLS = toolset.split(',') + ['zip'])
if not toolset and not path:
	defenv = Environment(TARGET_ARCH = arch)

Export('defenv')

######################################################################
#######  Includes                                                  ###
######################################################################

SConscript('SCons/utils.py')

######################################################################
#######  Options                                                   ###
######################################################################

import os
default_doctype = 'html'
if defenv.WhereIs('hhc', os.environ['PATH']):
	default_doctype = 'chm'

from time import strftime, gmtime
cvs_version = strftime('%d-%b-%Y.cvs', gmtime())

opts = Variables()

# load configuration options
#  it's important this will be done here so NSIS_CONFIG_CONST_DATA_PATH
#  will be available for the next few lines and so `dirs` can be set
SConscript('SCons/config.py')

opts.Update(defenv)
Help(opts.GenerateHelpText(defenv))

#Fix ListVariable to generate comma separated (quoted if required) list of allowed names:
org_ListVariable = ListVariable
def ListVariable(key, help, default, names, map={}):
	r = list(org_ListVariable(key, help, default, names, map))
	if len(r) == 5 and isinstance(r[1], str):
		fmt = 'allowed names: %s'
		repl = fmt % ', '.join( ((' ' in s) and ('"%s"' % s) or s) for s in names )
		r[1] = r[1].replace(fmt % ' '.join(names), repl)
	return r


install_dirs = {
	'relocatable': {
		'dest': '',
		'prefix': '',
		'conf': '$PREFIX',
		'bin': '$PREFIX',
		'data': '$PREFIX',
		'doc': '$PREFIX'
	},
	'static': {
		'dest': '',
		'prefix': '/usr/local',
		'conf': '$PREFIX/etc',
		'bin': '$PREFIX/bin',
		'data': '$PREFIX/share/nsis',
		'doc': '$PREFIX/share/doc/nsis'
	}
}

if 'NSIS_CONFIG_CONST_DATA_PATH' in defenv['NSIS_CPPDEFINES']:
	dirs = install_dirs['static']
else:
	dirs = install_dirs['relocatable']

if 'msvc' in defenv['TOOLS'] or 'mstoolkit' in defenv['TOOLS']:
	ignore_tests = 'none'
else:
	ignore_tests = ','.join(Split("""
Examples/makensis.nsi
Examples/gfx.nsi"""))

# version
opts.Add(('VERSION', 'Version of NSIS', cvs_version))
opts.Add(('VER_MAJOR', 'Major version of NSIS (recommended for dist-installer)', None))
opts.Add(('VER_MINOR', 'Minor version of NSIS (recommended for dist-installer)', None))
opts.Add(('VER_REVISION', 'Revision of NSIS', None))
opts.Add(('VER_BUILD', 'Build version of NSIS', None))
opts.Add(('VER_PACKED', 'Packed version of NSIS in 0xMMmmmrrb format, used for feature detection in scripts (recommended if VER_MAJOR and VER_MINOR are not set)', None))
# installation
opts.Add(('PREFIX', 'Installation prefix', dirs['prefix']))
opts.Add(ListVariable('SKIPSTUBS', 'A list of stubs that will not be built', 'none', stubs))
opts.Add(ListVariable('SKIPPLUGINS', 'A list of plug-ins that will not be built', 'none', plugin_libs + plugins))
opts.Add(ListVariable('SKIPUTILS', 'A list of utilities that will not be built', 'none', utils))
opts.Add(ListVariable('SKIPMISC', 'A list of plug-ins that will not be built', 'none', misc))
opts.Add(ListVariable('SKIPDOC', 'A list of doc files that will not be built/installed', 'none', doc))
opts.Add(('SKIPTESTS', 'A comma-separated list of test files that will not be ran', 'none'))
opts.Add(('IGNORETESTS', 'A comma-separated list of test files that will be ran but ignored', ignore_tests))
# build tools
opts.Add(('PATH', 'A colon-separated list of system paths instead of the default - TEMPORARY AND MAY DEPRECATE', None))
opts.Add(('TOOLSET', 'A comma-separated list of specific tools used for building instead of the default', None))
opts.Add(BoolVariable('MSTOOLKIT', 'Use Microsoft Visual C++ Toolkit', 'no'))
opts.Add(EnumVariable('MSVS_VERSION', 'MS Visual C++ version', os.environ.get('MSVS_VERSION'), allowed_values=('6.0', '7.0', '7.1', '8.0', '8.0Exp', '9.0', '9.0Exp', '10.0', '10.0Exp')))
opts.Add(EnumVariable('TARGET_ARCH', 'Target processor architecture', 'x86', allowed_values=('x86', 'amd64')))
opts.Add(ListVariable('DOCTYPES', 'A list of document types that will be built', default_doctype, doctypes))
opts.Add(('CC', 'Override C compiler', None))
opts.Add(('CXX', 'Override C++ compiler', None))
opts.Add(PathVariable('APPEND_CPPPATH', 'Additional paths to search for include files', None))
opts.Add(PathVariable('APPEND_LIBPATH', 'Additional paths to search for libraries', None))
opts.Add(('APPEND_CCFLAGS', 'Additional C/C++ compiler flags'))
opts.Add(('APPEND_LINKFLAGS', 'Additional linker flags'))
opts.Add(PathVariable('WXWIN', 'Path to wxWindows library folder (e.g. C:\\Dev\\wxWidgets-2.8.10)', os.environ.get('WXWIN')))
opts.Add(PathVariable('ZLIB_W32', 'Path to Win32 zlib library folder (e.g. C:\\Dev\\zlib-1.2.3)', os.environ.get('ZLIB_W32')))
# build options
opts.Add(BoolVariable('UNICODE', 'Build the Unicode version of the compiler and tools', 'yes'))
opts.Add(BoolVariable('DEBUG', 'Build executables with debugging information', 'no'))
opts.Add(PathVariable('CODESIGNER', 'A program used to sign executables', None))
opts.Add(BoolVariable('STRIP', 'Strips executables of any unrequired data such as symbols', 'yes'))
opts.Add(BoolVariable('STRIP_CP', 'Strips cross-platform executables of any unrequired data such as symbols', 'yes'))
opts.Add(BoolVariable('STRIP_W32', 'Strips Win32 executables of any unrequired data such as symbols', 'yes'))
# path related build options
opts.Add(('PREFIX_DEST', 'Intermediate installation prefix (extra install time prefix)', dirs['dest']))
opts.Add(('PREFIX_CONF', 'Path to install nsisconf.nsh to', dirs['conf']))
opts.Add(('PREFIX_BIN', 'Path to install native binaries to', dirs['bin']))
opts.Add(('PREFIX_DATA', 'Path to install nsis data to (plugins, includes, stubs, contrib, win32 binaries)', dirs['data']))
opts.Add(('PREFIX_DOC','Path to install nsis README / INSTALL / TODO files to.', dirs['doc']))
opts.Add(('PREFIX_PLUGINAPI_INC','Path to install plugin API headers to.', None))
opts.Add(('PREFIX_PLUGINAPI_LIB','Path to install plugin static library to.', None))

opts.Update(defenv)
Help(opts.GenerateHelpText(defenv))

if defenv['TARGET_ARCH'] != 'x86':
	defenv['UNICODE'] = True

if defenv['DEBUG']:
	defenv.Append(CPPDEFINES = ['DEBUG'])

# add prefixes defines
if 'NSIS_CONFIG_CONST_DATA_PATH' in defenv['NSIS_CPPDEFINES']:
	defenv.Append(NSIS_CPPDEFINES = [('PREFIX_CONF', '"%s"' % defenv.subst('$PREFIX_CONF'))])
	defenv.Append(NSIS_CPPDEFINES = [('PREFIX_DATA', '"%s"' % defenv.subst('$PREFIX_DATA'))])
	defenv.Append(NSIS_CPPDEFINES = [('PREFIX_DOC', '"%s"' % defenv.subst('$PREFIX_DOC'))])

# Need this early for the config header files to be placed in
if defenv['UNICODE']:
	if defenv['DEBUG']:
		defenv.Replace(BUILD_PREFIX = 'build/udebug')
	else:
		defenv.Replace(BUILD_PREFIX = 'build/urelease')
else:
	if defenv['DEBUG']:
		defenv.Replace(BUILD_PREFIX = 'build/debug')
	else:
		defenv.Replace(BUILD_PREFIX = 'build/release')

defenv.Replace(BUILD_CONFIG = defenv.subst('$BUILD_PREFIX/config'))

# ensure the config directory exists
if not Dir(defenv.Dir('#$BUILD_CONFIG')).exists():
	defenv.Execute(Mkdir(defenv.Dir('#$BUILD_CONFIG')))

# write configuration into sconf.h and defines.h
sconf_h = open(defenv.File('#$BUILD_CONFIG/nsis-sconf.h').abspath, 'w')
sconf_h.write('// This file is automatically generated by SCons\n// DO NOT EDIT THIS FILE\n')

defines_h = open(defenv.File('#$BUILD_CONFIG/nsis-defines.h').abspath, 'w')
defines_h.write('// This file is automatically generated by SCons\n// DO NOT EDIT THIS FILE\n')

for i in defenv['NSIS_CPPDEFINES']:
	if type(i) is not str:
		sconf_h.write('#define %s %s\n' % (i[0], i[1]))
		if str(i[1])[0] != '"':
			defines_h.write('definedlist.add(_T("%s"), _T("%s"));\n' % (i[0], i[1]))
		else:
			defines_h.write('definedlist.add(_T("%s"), _T(%s));\n' % (i[0], i[1]))
	else:
		sconf_h.write('#define %s\n' % (i))
		defines_h.write('definedlist.add(_T("%s"));\n' % (i))
sconf_h.close()
defines_h.close()

# write version into version.h
f = open(defenv.File('#$BUILD_CONFIG/nsis-version.h').abspath, 'w')
f.write('// This file is automatically generated by SCons\n// DO NOT EDIT THIS FILE\n')
f.write('#include "%s"\n' % File('#/Source/tchar.h').abspath)

if (not defenv.has_key('VER_PACKED')) and defenv.has_key('VER_MAJOR') and defenv.has_key('VER_MINOR'):
	packed_r = packed_b = 0
	if defenv.has_key('VER_REVISION'):
		packed_r = int(defenv['VER_REVISION'])
	if defenv.has_key('VER_BUILD'):
		packed_b = int(defenv['VER_BUILD'])
	defenv['VER_PACKED'] = '0x%0.2i%0.3i%0.2i%0.1i' % (int(defenv['VER_MAJOR']),int(defenv['VER_MINOR']),packed_r,packed_b)
if defenv.has_key('VER_PACKED'):
	f.write('#define NSIS_PACKEDVERSION _T("%s")\n' % defenv['VER_PACKED'])

if defenv.has_key('VER_MAJOR') and defenv.get('VERSION','') == '':
	defenv['VERSION'] = defenv['VER_MAJOR']
	if defenv.has_key('VER_MINOR'):
		defenv['VERSION'] += '.' + defenv['VER_MINOR']
	if defenv.has_key('VER_REVISION'):
		defenv['VERSION'] += '.' + defenv['VER_REVISION']

if (not defenv.has_key('TARGET_ARCH')) or defenv['TARGET_ARCH'] == 'x86':
	vermaj = 0
	if defenv.has_key('VER_MAJOR'):
		vermaj = int(defenv['VER_MAJOR'])

f.write('#define NSIS_VERSION _T("v%s")\n' % defenv['VERSION'])

f.close()

######################################################################
#######  Common Functions                                          ###
######################################################################

def SafeFile(f):
	from types import StringType

	if isinstance(f, StringType):
		return File(f)

	return f

def MakeFileList(files):
	return Flatten(File(files))

def AddEnvStandardFlags(env, defines=None, flags=None, libs=None, entry=None, nodeflib=None):
	if defines:
		env.Append(CPPDEFINES = defines)
	if flags:
		env.Append(CCFLAGS = flags)
	if libs:
		env.Append(LIBS = libs)

	if entry:
		unicodestr = "None"
		if 'UNICODE' in env['CPPDEFINES']:
			unicodestr = "True"
		env.Append(LINKFLAGS = ['${ENTRY_FLAG("%s",%s)}' % (entry,unicodestr)])

	if nodeflib:
		env.Append(LINKFLAGS = ['$NODEFLIBS_FLAG']) # no default libraries

def AppendRES(env, source, res, resources):
	if res:
		target = MakeFileList(res)[0].name.replace('.rc', '-rc')
		target_res = env.RES(target, res)
		if resources:
			env.Depends(target_res, resources)
		source.append(target_res)

def CleanMap(env, target, target_name):
	env.Clean(target, File(target_name + '.map'))


######################################################################
#######  Functions                                                 ###
######################################################################

defenv['ZIPDISTDIR'] = defenv.Dir('#nsis-$VERSION')
defenv['INSTDISTDIR'] = defenv.Dir('#.instdist')

=== debian/changelog ===
nsis (3.03-1) experimental; urgency=low

  * New 3.03 upstream release:
    - Add Library.nsi to ignored examples

  * Packaging cleanup
    - Cleanup d/control thanks to cme
    - Update debian/copyright for new upstream release thanks to cme
    - Bump debhelper compat to 11
    - Update Vcs-* fields for the move to salsa

 -- Didier Raboud <odyx@debian.org>  Tue, 27 Feb 2018 14:14:01 +0100

=== debian/control ===
Source: nsis
Maintainer: Thomas Gaugler <thomas@dadie.net>
Uploaders: Didier Raboud <odyx@debian.org>
Section: devel
Priority: optional
Build-Depends: debhelper (>= 11),
               docbook-xsl-ns,
               docbook5-xml,
               dpkg-dev (>= 1.17.0),
               html2text,
               libcppunit-dev,
               mingw-w64,
               scons,
               xsltproc,
               zlib1g-dev
Standards-Version: 4.1.3
Vcs-Browser: https://salsa.debian.org/debian/nsis
Vcs-Git: https://salsa.debian.org/debian/nsis.git
Homepage: http://nsis.sourceforge.net/

Package: nsis
Architecture: any
Depends: nsis-common (>= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: mingw-w64,
          nsis-doc (>= ${source:Version}),
          nsis-pluginapi (>= ${source:Version}),
          wine [amd64 i386 kfreebsd-amd64 kfreebsd-i386 powerpc]
Description: Nullsoft Scriptable Install System (modified for Debian)
 NSIS is a tool for creating quick and user friendly installers for
 Microsoft Windows (Win32) operating systems.
 .
 NSIS creates installers that are capable of installing, uninstalling,
 setting system settings, extracting files, etc. Because it's based on
 script files, you can fully control every part of your installers. The
 script language supports variables, functions, string manipulation,
 just like a normal programming language - but designed for the creation
 of installers. Even with all these features, NSIS is still the smallest
 installer system available. With the default options, it has an overhead
 of only 34 KB.

Package: nsis-common
Architecture: all
Depends: ${misc:Depends}
Description: Nullsoft Scriptable Install System stubs and plugins
 NSIS is a tool for creating quick and user friendly installers for
 Microsoft Windows (Win32) operating systems.
 .
 This package contains the stubs and plugins of NSIS.

Package: nsis-pluginapi
Architecture: all
Depends: ${misc:Depends}
Recommends: mingw-w64
Enhances: nsis (>= ${source:Version})
Description: Nullsoft Scriptable Install System plugin API
 NSIS is a tool for creating quick and user friendly installers for
 Microsoft Windows (Win32) operating systems.
 .
 This package contains the header and library files for developing
 NSIS plugins.

Package: nsis-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Nullsoft Scriptable Install System documentation
 NSIS is a tool for creating quick and user friendly installers for
 Microsoft Windows (Win32) operating systems.
 .
 This package contains examples and the documentation in HTML format.

=== debian/rules ===
--- 
+++ 
@@ -100,7 +100,7 @@
 INSTALL_FLAGS_nsis-doc = $(SCONSOPTS_HOST)
 
 # Exclude test scripts which are not appropriate for POSIX platforms.
-IGNORE_TESTS = makensis.nsi|gfx.nsi
+IGNORE_TESTS = makensis.nsi|gfx.nsi|Library.nsi
 
 # Path to .nsi scripts
 SCRIPTS_PATH = $(DOCDIR)/Examples

## nsis 3.04

=== SConstruct ===
--- 
+++ 
@@ -30,7 +30,6 @@
 ]
 
 utils = [
-	'Library/LibraryLocal',
 	'Library/RegTool',
 	'MakeLangId',
 	'Makensisw',
@@ -143,12 +142,11 @@
 else:
 	dirs = install_dirs['relocatable']
 
-if 'msvc' in defenv['TOOLS'] or 'mstoolkit' in defenv['TOOLS']:
+if defenv['PLATFORM'] == 'win32':
 	ignore_tests = 'none'
 else:
 	ignore_tests = ','.join(Split("""
-Examples/makensis.nsi
-Examples/gfx.nsi"""))
+Examples/makensis.nsi"""))
 
 # version
 opts.Add(('VERSION', 'Version of NSIS', cvs_version))
@@ -161,7 +159,7 @@
 opts.Add(('PREFIX', 'Installation prefix', dirs['prefix']))
 opts.Add(ListVariable('SKIPSTUBS', 'A list of stubs that will not be built', 'none', stubs))
 opts.Add(ListVariable('SKIPPLUGINS', 'A list of plug-ins that will not be built', 'none', plugin_libs + plugins))
-opts.Add(ListVariable('SKIPUTILS', 'A list of utilities that will not be built', 'none', utils))
+opts.Add(ListVariable('SKIPUTILS', 'A list of utilities that will not be built', 'NSIS Menu', utils))
 opts.Add(ListVariable('SKIPMISC', 'A list of plug-ins that will not be built', 'none', misc))
 opts.Add(ListVariable('SKIPDOC', 'A list of doc files that will not be built/installed', 'none', doc))
 opts.Add(('SKIPTESTS', 'A comma-separated list of test files that will not be ran', 'none'))
@@ -171,7 +169,7 @@
 opts.Add(('TOOLSET', 'A comma-separated list of specific tools used for building instead of the default', None))
 opts.Add(BoolVariable('MSTOOLKIT', 'Use Microsoft Visual C++ Toolkit', 'no'))
 opts.Add(EnumVariable('MSVS_VERSION', 'MS Visual C++ version', os.environ.get('MSVS_VERSION'), allowed_values=('6.0', '7.0', '7.1', '8.0', '8.0Exp', '9.0', '9.0Exp', '10.0', '10.0Exp')))
-opts.Add(EnumVariable('TARGET_ARCH', 'Target processor architecture', 'x86', allowed_values=('x86', 'amd64')))
+opts.Add(EnumVariable('TARGET_ARCH', 'Target processor architecture', 'x86', allowed_values=('x86', 'amd64', 'arm64')))
 opts.Add(ListVariable('DOCTYPES', 'A list of document types that will be built', default_doctype, doctypes))
 opts.Add(('CC', 'Override C compiler', None))
 opts.Add(('CXX', 'Override C++ compiler', None))
@@ -256,14 +254,28 @@
 f.write('#include "%s"\n' % File('#/Source/tchar.h').abspath)
 
 if (not defenv.has_key('VER_PACKED')) and defenv.has_key('VER_MAJOR') and defenv.has_key('VER_MINOR'):
-	packed_r = packed_b = 0
-	if defenv.has_key('VER_REVISION'):
-		packed_r = int(defenv['VER_REVISION'])
-	if defenv.has_key('VER_BUILD'):
-		packed_b = int(defenv['VER_BUILD'])
-	defenv['VER_PACKED'] = '0x%0.2i%0.3i%0.2i%0.1i' % (int(defenv['VER_MAJOR']),int(defenv['VER_MINOR']),packed_r,packed_b)
-if defenv.has_key('VER_PACKED'):
-	f.write('#define NSIS_PACKEDVERSION _T("%s")\n' % defenv['VER_PACKED'])
+	packed_r = int(defenv.get('VER_REVISION','0'))
+	packed_b = int(defenv.get('VER_BUILD','0'))
+	defenv['VER_PACKED'] = '0x%0.2i%0.3i%0.2i%0.1i' % (int(defenv['VER_MAJOR']), int(defenv['VER_MINOR']), packed_r, packed_b)
+if not defenv.has_key('VER_PACKED'):
+	import re
+	found = None
+	for v in re.compile(r'^\\H\{[v]?(\S+)\}', re.M).finditer(File('#/Docs/src/history.but').get_contents()): # Try to parse the Halibut history file
+		if v and not found:
+			v = v.group(1).split('.')
+			if len(v) >= 2:
+				mi = int(re.search(r'\d+', v[1]).group())
+				if mi < 1: mi = 1 # Make sure we can subtract 1 from the minor number so trunk stays below the next release
+				defenv['VER_PACKED'] = '0x%0.2i%0.3i%0.2i%0.1i' % (int(re.search(r'\d+', v[0]).group()), mi - 1, 66, 6)
+				if int(defenv['VER_PACKED'], 0) >= int('0x03000000', 0):
+					found = v
+	if not found:
+		defenv['VER_PACKED'] = '0x%0.2i%0.3i%0.2i%0.1i' % (3, 3, 42, 0) # Default to a version number we never used
+	print('WARNING: VER_PACKED not set, defaulting to %s!' % defenv['VER_PACKED'])
+if int(defenv['VER_PACKED'], 0) < int('0x03000000', 0) or int(defenv['VER_PACKED'], 0) >= int('0x04000000', 0):
+	print('ERROR: Invalid VER_PACKED value!')
+	Exit(1)
+f.write('#define NSIS_PACKEDVERSION _T("%s")\n' % defenv['VER_PACKED'])
 
 if defenv.has_key('VER_MAJOR') and defenv.get('VERSION','') == '':
 	defenv['VERSION'] = defenv['VER_MAJOR']
@@ -271,12 +283,6 @@
 		defenv['VERSION'] += '.' + defenv['VER_MINOR']
 	if defenv.has_key('VER_REVISION'):
 		defenv['VERSION'] += '.' + defenv['VER_REVISION']
-
-if (not defenv.has_key('TARGET_ARCH')) or defenv['TARGET_ARCH'] == 'x86':
-	vermaj = 0
-	if defenv.has_key('VER_MAJOR'):
-		vermaj = int(defenv['VER_MAJOR'])
-
 f.write('#define NSIS_VERSION _T("v%s")\n' % defenv['VERSION'])
 
 f.close()
@@ -284,6 +290,19 @@
 ######################################################################
 #######  Common Functions                                          ###
 ######################################################################
+
+def GetArcCPU(env):
+	if (not env.has_key('TARGET_ARCH')) or env['TARGET_ARCH'] == 'x86':
+		return 'x86'
+	return env['TARGET_ARCH']
+
+def GetArcSuffix(env, unicode = None):
+	if unicode is None:
+		unicode = 'UNICODE' in env['CPPDEFINES']
+	suff = '-unicode'
+	if not unicode:
+		suff = '-ansi'
+	return GetArcCPU(env) + suff
 
 def SafeFile(f):
 	from types import StringType
@@ -298,36 +317,3 @@
 
 def AddEnvStandardFlags(env, defines=None, flags=None, libs=None, entry=None, nodeflib=None):
 	if defines:
-		env.Append(CPPDEFINES = defines)
-	if flags:
-		env.Append(CCFLAGS = flags)
-	if libs:
-		env.Append(LIBS = libs)
-
-	if entry:
-		unicodestr = "None"
-		if 'UNICODE' in env['CPPDEFINES']:
-			unicodestr = "True"
-		env.Append(LINKFLAGS = ['${ENTRY_FLAG("%s",%s)}' % (entry,unicodestr)])
-
-	if nodeflib:
-		env.Append(LINKFLAGS = ['$NODEFLIBS_FLAG']) # no default libraries
-
-def AppendRES(env, source, res, resources):
-	if res:
-		target = MakeFileList(res)[0].name.replace('.rc', '-rc')
-		target_res = env.RES(target, res)
-		if resources:
-			env.Depends(target_res, resources)
-		source.append(target_res)
-
-def CleanMap(env, target, target_name):
-	env.Clean(target, File(target_name + '.map'))
-
-
-######################################################################
-#######  Functions                                                 ###
-######################################################################
-
-defenv['ZIPDISTDIR'] = defenv.Dir('#nsis-$VERSION')
-defenv['INSTDISTDIR'] = defenv.Dir('#.instdist')

=== debian/changelog ===
nsis (3.04-1) unstable; urgency=medium

  * New 3.04 upstream release

  [ Thomas Gaugler ]
  * Provide decomposed version to indirectly set packed version
  * Remove LibraryLocal from build following upstream

  [ Ondřej Nový ]
  * d/changelog: Remove trailing whitespaces
  * d/rules: Remove trailing whitespaces
  * d/watch: Use https protocol

 -- Thomas Gaugler <thomas@dadie.net>  Mon, 07 Jan 2019 08:40:25 +0100

nsis (3.03-2) unstable; urgency=low

  * Migrate NSIS 3 to unstable

  [ Thomas Gaugler ]
  * Correct and refactor SKIPUTILS parameter setting
  * Reactivate Library.nsi test case

  [ Didier Raboud ]
  * Add gbp.conf
  * Mark nsis-{common,pluginapi,doc} Multi-Arch: foreign

 -- Didier Raboud <odyx@debian.org>  Sat, 31 Mar 2018 14:53:58 +0200

=== debian/control ===
--- 
+++ 
@@ -42,6 +42,7 @@
 
 Package: nsis-common
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends}
 Description: Nullsoft Scriptable Install System stubs and plugins
  NSIS is a tool for creating quick and user friendly installers for
@@ -51,6 +52,7 @@
 
 Package: nsis-pluginapi
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends}
 Recommends: mingw-w64
 Enhances: nsis (>= ${source:Version})
@@ -63,6 +65,7 @@
 
 Package: nsis-doc
 Architecture: all
+Multi-Arch: foreign
 Section: doc
 Depends: ${misc:Depends}
 Description: Nullsoft Scriptable Install System documentation

=== debian/rules ===
--- 
+++ 
@@ -18,6 +18,15 @@
 UNICODE=yes
 TESTDIR=$(CURDIR)/$(BUILDDIR)/test
 
+# Decomposition of version string
+define SPLIT
+	$(if $(2),$(call SPLIT,$(subst $(firstword $(2)), ,$(1)),$(filter-out $(firstword $(2)), $(2))), $(1))
+endef
+VERSION_DECOMPOSED=$(call SPLIT,$(VERSION),. -)
+VER_MAJOR=$(firstword $(VERSION_DECOMPOSED))
+VER_MINOR=$(word 2,$(VERSION_DECOMPOSED))
+VER_REVISION=$(word 3,$(VERSION_DECOMPOSED))
+
 # Variables for Win32/Win64 cross compiler
 XGCC_W32_X86 = i686-w64-mingw32-gcc
 XGCC_W32_X86_PATH = $(abspath $(shell $(XGCC_W32_X86) -print-file-name=libkernel32.a)/../..)
@@ -40,7 +49,8 @@
   $(shell dpkg-buildflags --get CFLAGS)" \
   APPEND_LINKFLAGS="$(shell dpkg-buildflags --get LDFLAGS)"
 
-SCONSOPTS = $(SCONSFLAGS) VERSION=$(VERSION) \
+SCONSOPTS = $(SCONSFLAGS) VERSION=$(VERSION) VER_MAJOR=$(VER_MAJOR) \
+  VER_MINOR=$(VER_MINOR) VER_REVISION=$(VER_REVISION) \
   PREFIX=$(PREFIX) PREFIX_CONF=$(SYSCONF) CHMDOCS=0 \
   STRIP_CP=no \
   $(if $(findstring nostripfull,$(DEB_BUILD_OPTIONS)),STRIP_W32=no,)
@@ -73,16 +83,17 @@
 
 COMMA := ,
 
-UTILS_ALL = 'Library/LibraryLocal,Library/RegTool,MakeLangId,Makensisw,NSIS Menu,UIs,SubStart,VPatch/Source/GenPat,zip2exe'
-
-IGNORE_UTILS_NSIS   := $(subst Library/LibraryLocal$(COMMA),,$(UTILS_ALL))
-IGNORE_UTILS_NSIS   := $(subst $(COMMA)VPatch/Source/GenPat,,$(IGNORE_UTILS_NSIS))
-IGNORE_UTILS_COMMON := $(subst $(COMMA)Library/RegTool$,,$(UTILS_ALL))
+UTILS_ALL = 'Library/RegTool,MakeLangId,Makensisw,NSIS Menu,UIs,SubStart,VPatch/Source/GenPat,zip2exe'
+
+# Only build GenPat for the host system
+IGNORE_UTILS_NSIS   := $(subst $(COMMA)VPatch/Source/GenPat,,$(UTILS_ALL))
+
+# Build the win32 user interfaces (UIs) and RegTool
+IGNORE_UTILS_COMMON := $(subst Library/RegTool,,$(UTILS_ALL))
 IGNORE_UTILS_COMMON := $(subst $(COMMA)UIs,,$(IGNORE_UTILS_COMMON))
 
-IGNORE_UTILS_CLEAN  := $(IGNORE_UTILS_COMMON)
-IGNORE_UTILS_CLEAN  := $(subst Library/LibraryLocal$(COMMA),,$(IGNORE_UTILS_COMMON))
-IGNORE_UTILS_CLEAN  := $(subst $(COMMA)VPatch/Source/GenPat,,$(IGNORE_UTILS_CLEAN))
+# Clean everything except zip2exe pulling in a dependency on win32 zlib dll
+IGNORE_UTILS_CLEAN  := zip2exe
 
 SCONSOPTS_HOST   := $(SCONSHOSTFLAGS) $(SCONSOPTS) \
   SKIPUTILS=$(IGNORE_UTILS_NSIS) SKIPDOC=COPYING
@@ -100,7 +111,7 @@
 INSTALL_FLAGS_nsis-doc = $(SCONSOPTS_HOST)
 
 # Exclude test scripts which are not appropriate for POSIX platforms.
-IGNORE_TESTS = makensis.nsi|gfx.nsi|Library.nsi
+IGNORE_TESTS = makensis.nsi|gfx.nsi
 
 # Path to .nsi scripts
 SCRIPTS_PATH = $(DOCDIR)/Examples
@@ -205,17 +216,5 @@
 			|| exit 1; \
 		fi;; \
 		esac; \
-	done; 
+	done;
 	# Fail the build if libwinpthread is needed at runtime (see #722898)
-	test `find $(TESTDIR)$(DATADIR)/Plugins -iname "*.dll" -exec objdump -p {} \; | grep -E "file format|DLL Name" | grep -cim1 libwinpthread` -eq 0
-endif
-
-override_dh_auto_install-arch:
-	$(foreach p,$(shell dh_listpackages -a),$(call DO_SCONS_INSTALL,$(p)))
-
-override_dh_fixperms-arch:
-	dh_fixperms
-	find "$(CURDIR)/debian/nsis/$(SYSCONF)" \
-		-type f -perm /111 -exec chmod a-x {} \;
-
-override_dh_auto_install-indep:
